/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.stimmeingabe.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="STIMMEINGABE_PLAUSI.WahlAndErgebniseingangsartAndGebietsartAndTyp",
     query="SELECT obj FROM StimmeingabePlausiKonfiguration obj WHERE obj.wahl = ?1 AND obj.ergebniseingangsart = ?2 AND obj.gebietsart = ?3 AND obj.typ = ?4",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STIMMEINGABE_PLAUSI.WahlAndErgebniseingangsartAndGebietsart",
     query="SELECT obj FROM StimmeingabePlausiKonfiguration obj WHERE obj.wahl = ?1 AND obj.ergebniseingangsart = ?2 AND obj.gebietsart = ?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="STIMMEINGABE_PLAUSI.Wahl",
     query="SELECT obj FROM StimmeingabePlausiKonfiguration obj WHERE obj.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "STIMMEINGABE_PLAUSI")
// @javax.persistence.IdClass(StimmeingabePlausiKonfigurationPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class StimmeingabePlausiKonfiguration
extends AbstractStimmeingabePlausiKonfiguration
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected StimmeingabePlausiKonfiguration() {
    super();
  }
    public StimmeingabePlausiKonfiguration(de.ivu.elect.jee.entity.customdata.CustomData customData){
                      if (customData != null && de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE != customData) {
          customData.setTechnicalEntity(this);
          customDataStorage = new de.ivu.elect.business.customdata.entity.CustomDataStorage(customData);
        }
            }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public StimmeingabePlausiKonfiguration(StimmeingabePlausiKonfiguration original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "stimmeingabe_plausi_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "StimmeingabePlausiKonfiguration")
    @javax.persistence.TableGenerator(name = "StimmeingabePlausiKonfiguration", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "StimmeingabePlausiKonfiguration", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient StimmeingabePlausiKonfigurationPK pkCache;

  @Override
  public StimmeingabePlausiKonfigurationPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new StimmeingabePlausiKonfigurationPK(getId());
    }

    return pkCache;
  }

  public static <E extends StimmeingabePlausiKonfiguration> java.util.Map<StimmeingabePlausiKonfigurationPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<StimmeingabePlausiKonfigurationPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends StimmeingabePlausiKonfiguration> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBeschreibung = false;
          hasChangedErgebniseingangsart = false;
          hasChangedFehlerart = false;
          hasChangedFehlermeldungFormat = false;
          hasChangedFehlerschluessel = false;
          hasChangedGebietsart = false;
          hasChangedStatus = false;
          hasChangedTyp = false;
  
      hasChangedCustomDataStorage = false;
        hasChangedWahl = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BESCHREIBUNG", nullable = StimmeingabePlausiKonfigurationConstants.BESCHREIBUNG_NULLABLE, length=StimmeingabePlausiKonfigurationConstants.BESCHREIBUNG_MAX_LENGTH)
        
  protected java.lang.String beschreibung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBeschreibung = false;

  public boolean hasChangedBeschreibung(){
    return hasChangedBeschreibung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBeschreibung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBeschreibung;
  
  /**
   * 
   *
   * getter for STIMMEINGABE_PLAUSI.BESCHREIBUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBeschreibung() {
        return beschreibung;
      }

  /**
   * 
   *
   * setter for STIMMEINGABE_PLAUSI.BESCHREIBUNG
   *
   * @param beschreibung
   */
  @Override   public void setBeschreibung(@javax.annotation.Nullable  java.lang.String beschreibung) {

       resetTkCache();
                  
                          java.lang.String beschreibungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(beschreibung, StimmeingabePlausiKonfigurationConstants.BESCHREIBUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.beschreibung
      , beschreibungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBeschreibung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("beschreibung");
      }


             if (!isSeitLadenVeraendertBeschreibung) {
          isSeitLadenVeraendertBeschreibung = thisAttributChanged;
         if (isSeitLadenVeraendertBeschreibung){
           wertNachLadenBeschreibung=this.beschreibung;
         }
       }
      

       this.beschreibung = beschreibungInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "PLAUSI_ERGEBNISART", nullable = StimmeingabePlausiKonfigurationConstants.PLAUSI_ERGEBNISART_NULLABLE)
    
  protected de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart ergebniseingangsart =  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedErgebniseingangsart = false;

  public boolean hasChangedErgebniseingangsart(){
    return hasChangedErgebniseingangsart;
  }
  
  /**
   * 
   *
   * getter for STIMMEINGABE_PLAUSI.PLAUSI_ERGEBNISART
   */
    @Override   public  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart getErgebniseingangsart() {
        return ergebniseingangsart;
      }

  /**
   * 
   *
   * setter for STIMMEINGABE_PLAUSI.PLAUSI_ERGEBNISART
   *
   * @param ergebniseingangsart
   */
  @Override   public void setErgebniseingangsart( de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart ergebniseingangsart) {

       resetTkCache();
                  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiErgebniseingangsart ergebniseingangsartInternal = ergebniseingangsart;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebniseingangsart
      , ergebniseingangsartInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebniseingangsart |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebniseingangsart");
      }


      

       this.ergebniseingangsart = ergebniseingangsartInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "PLAUSI_FEHLERART", nullable = StimmeingabePlausiKonfigurationConstants.PLAUSI_FEHLERART_NULLABLE)
    
  protected de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiFehlerart fehlerart =  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiFehlerart.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedFehlerart = false;

  public boolean hasChangedFehlerart(){
    return hasChangedFehlerart;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertFehlerart = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiFehlerart wertNachLadenFehlerart;
  
  /**
   * 
   *
   * getter for STIMMEINGABE_PLAUSI.PLAUSI_FEHLERART
   */
    @Override   public  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiFehlerart getFehlerart() {
        return fehlerart;
      }

  /**
   * 
   *
   * setter for STIMMEINGABE_PLAUSI.PLAUSI_FEHLERART
   *
   * @param fehlerart
   */
  @Override   public void setFehlerart( de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiFehlerart fehlerart) {

       resetTkCache();
                  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiFehlerart fehlerartInternal = fehlerart;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.fehlerart
      , fehlerartInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedFehlerart |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("fehlerart");
      }


             if (!isSeitLadenVeraendertFehlerart) {
          isSeitLadenVeraendertFehlerart = thisAttributChanged;
         if (isSeitLadenVeraendertFehlerart){
           wertNachLadenFehlerart=this.fehlerart;
         }
       }
      

       this.fehlerart = fehlerartInternal;

         }

        
  @javax.persistence.Column(name = "PLAUSI_FEHLERMELDUNG", nullable = StimmeingabePlausiKonfigurationConstants.PLAUSI_FEHLERMELDUNG_NULLABLE, length=StimmeingabePlausiKonfigurationConstants.PLAUSI_FEHLERMELDUNG_MAX_LENGTH)
        
  protected java.lang.String fehlermeldungFormat =  null;

  @javax.persistence.Transient
  protected boolean hasChangedFehlermeldungFormat = false;

  public boolean hasChangedFehlermeldungFormat(){
    return hasChangedFehlermeldungFormat;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertFehlermeldungFormat = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenFehlermeldungFormat;
  
  /**
   * 
   *
   * getter for STIMMEINGABE_PLAUSI.PLAUSI_FEHLERMELDUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getFehlermeldungFormat() {
        return fehlermeldungFormat;
      }

  /**
   * 
   *
   * setter for STIMMEINGABE_PLAUSI.PLAUSI_FEHLERMELDUNG
   *
   * @param fehlermeldungFormat
   */
  @Override   public void setFehlermeldungFormat(@javax.annotation.Nullable  java.lang.String fehlermeldungFormat) {

       resetTkCache();
                  
                          java.lang.String fehlermeldungFormatInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(fehlermeldungFormat, StimmeingabePlausiKonfigurationConstants.PLAUSI_FEHLERMELDUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.fehlermeldungFormat
      , fehlermeldungFormatInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedFehlermeldungFormat |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("fehlermeldungFormat");
      }


             if (!isSeitLadenVeraendertFehlermeldungFormat) {
          isSeitLadenVeraendertFehlermeldungFormat = thisAttributChanged;
         if (isSeitLadenVeraendertFehlermeldungFormat){
           wertNachLadenFehlermeldungFormat=this.fehlermeldungFormat;
         }
       }
      

       this.fehlermeldungFormat = fehlermeldungFormatInternal;

         }

        
  @javax.persistence.Column(name = "PLAUSI_FEHLERSCHLUESSEL", nullable = StimmeingabePlausiKonfigurationConstants.PLAUSI_FEHLERSCHLUESSEL_NULLABLE, length=StimmeingabePlausiKonfigurationConstants.PLAUSI_FEHLERSCHLUESSEL_MAX_LENGTH)
        
  protected java.lang.String fehlerschluessel =  null;

  @javax.persistence.Transient
  protected boolean hasChangedFehlerschluessel = false;

  public boolean hasChangedFehlerschluessel(){
    return hasChangedFehlerschluessel;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertFehlerschluessel = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenFehlerschluessel;
  
  /**
   * 
   *
   * getter for STIMMEINGABE_PLAUSI.PLAUSI_FEHLERSCHLUESSEL
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getFehlerschluessel() {
        return fehlerschluessel;
      }

  /**
   * 
   *
   * setter for STIMMEINGABE_PLAUSI.PLAUSI_FEHLERSCHLUESSEL
   *
   * @param fehlerschluessel
   */
  @Override   public void setFehlerschluessel(@javax.annotation.Nullable  java.lang.String fehlerschluessel) {

       resetTkCache();
                  
                          java.lang.String fehlerschluesselInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(fehlerschluessel, StimmeingabePlausiKonfigurationConstants.PLAUSI_FEHLERSCHLUESSEL_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.fehlerschluessel
      , fehlerschluesselInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedFehlerschluessel |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("fehlerschluessel");
      }


             if (!isSeitLadenVeraendertFehlerschluessel) {
          isSeitLadenVeraendertFehlerschluessel = thisAttributChanged;
         if (isSeitLadenVeraendertFehlerschluessel){
           wertNachLadenFehlerschluessel=this.fehlerschluessel;
         }
       }
      

       this.fehlerschluessel = fehlerschluesselInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "PLAUSI_GEBIETSART", nullable = StimmeingabePlausiKonfigurationConstants.PLAUSI_GEBIETSART_NULLABLE)
    
  protected de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart gebietsart =  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedGebietsart = false;

  public boolean hasChangedGebietsart(){
    return hasChangedGebietsart;
  }
  
  /**
   * 
   *
   * getter for STIMMEINGABE_PLAUSI.PLAUSI_GEBIETSART
   */
    @Override   public  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart getGebietsart() {
        return gebietsart;
      }

  /**
   * 
   *
   * setter for STIMMEINGABE_PLAUSI.PLAUSI_GEBIETSART
   *
   * @param gebietsart
   */
  @Override   public void setGebietsart( de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart gebietsart) {

       resetTkCache();
                  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiGebietsart gebietsartInternal = gebietsart;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gebietsart
      , gebietsartInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedGebietsart |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("gebietsart");
      }


      

       this.gebietsart = gebietsartInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "PLAUSI_STATUS", nullable = StimmeingabePlausiKonfigurationConstants.PLAUSI_STATUS_NULLABLE)
    
  protected de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiStatus status =  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiStatus.AKTIVIERT;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiStatus wertNachLadenStatus;
  
  /**
   * 
   *
   * getter for STIMMEINGABE_PLAUSI.PLAUSI_STATUS
   */
    @Override   public  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for STIMMEINGABE_PLAUSI.PLAUSI_STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiStatus status) {

       resetTkCache();
                  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


             if (!isSeitLadenVeraendertStatus) {
          isSeitLadenVeraendertStatus = thisAttributChanged;
         if (isSeitLadenVeraendertStatus){
           wertNachLadenStatus=this.status;
         }
       }
      

       this.status = statusInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STIMMEINGABE_PLAUSI_TYP", nullable = StimmeingabePlausiKonfigurationConstants.STIMMEINGABE_PLAUSI_TYP_NULLABLE)
    
  protected de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp typ =  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedTyp = false;

  public boolean hasChangedTyp(){
    return hasChangedTyp;
  }
  
  /**
   * 
   *
   * getter for STIMMEINGABE_PLAUSI.STIMMEINGABE_PLAUSI_TYP
   */
    @Override   public  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp getTyp() {
        return typ;
      }

  /**
   * 
   *
   * setter for STIMMEINGABE_PLAUSI.STIMMEINGABE_PLAUSI_TYP
   *
   * @param typ
   */
  @Override   public void setTyp( de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp typ) {

       resetTkCache();
                  de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiTyp typInternal = typ;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.typ
      , typInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedTyp |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("typ");
      }


      

       this.typ = typInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu CustomDataStorage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CUSTOM_DATA_STORAGE_ID", referencedColumnName="CUSTOM_DATA_STORAGE_ID"))
  protected de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage;

  /**
   * 
   */
  @Override
  public void setCustomDataStorage(@javax.annotation.Nullable  de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customDataStorage
    , customDataStorage);

    attributeChanged |= thisAttributChanged;

    hasChangedCustomDataStorage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("customDataStorage");
    }

    this.customDataStorage = customDataStorage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.customdata.entity.CustomDataStorage getCustomDataStorage(){
    return this.customDataStorage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCustomDataStorage = false;

  public boolean hasChangedCustomDataStorage(){
    return hasChangedCustomDataStorage;
  }

  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl( de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("StimmeingabePlausiKonfiguration:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(StimmeingabePlausiKonfiguration other){
                             other.beschreibung = this.beschreibung;
                                other.ergebniseingangsart = this.ergebniseingangsart;
                                other.fehlerart = this.fehlerart;
                                other.fehlermeldungFormat = this.fehlermeldungFormat;
                                other.fehlerschluessel = this.fehlerschluessel;
                                other.gebietsart = this.gebietsart;
                                other.status = this.status;
                                other.typ = this.typ;
           
  other.setCustomDataStorage(this.getCustomDataStorage());
  other.setWahl(this.getWahl());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(StimmeingabePlausiKonfiguration.class)){
        copyEntityAttributesUsingSetter((StimmeingabePlausiKonfiguration) other.castTo(StimmeingabePlausiKonfiguration.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von StimmeingabePlausiKonfiguration: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(StimmeingabePlausiKonfiguration other){
               other.setBeschreibung(this.beschreibung);
                  other.setErgebniseingangsart(this.ergebniseingangsart);
                  other.setFehlerart(this.fehlerart);
                  other.setFehlermeldungFormat(this.fehlermeldungFormat);
                  other.setFehlerschluessel(this.fehlerschluessel);
                  other.setGebietsart(this.gebietsart);
                  other.setStatus(this.status);
                  other.setTyp(this.typ);
       
    other.setCustomDataXml(this.getCustomDataXml());
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(StimmeingabePlausiKonfiguration other){
                       if (hasChangedBeschreibung) {
        other.setBeschreibung(this.beschreibung);
      }
                             if (hasChangedErgebniseingangsart) {
        other.setErgebniseingangsart(this.ergebniseingangsart);
      }
                             if (hasChangedFehlerart) {
        other.setFehlerart(this.fehlerart);
      }
                             if (hasChangedFehlermeldungFormat) {
        other.setFehlermeldungFormat(this.fehlermeldungFormat);
      }
                             if (hasChangedFehlerschluessel) {
        other.setFehlerschluessel(this.fehlerschluessel);
      }
                             if (hasChangedGebietsart) {
        other.setGebietsart(this.gebietsart);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedTyp) {
        other.setTyp(this.typ);
      }
             }




    /**
    * Hat die Entität überhaupt einen CustomDataStorage?
    */
    private boolean isCustomDataSupported() {
      return getCustomDataStorage()!=null;
    }

    @Override
    public de.ivu.elect.jee.entity.customdata.CustomData getCustomData() {
      if (isCustomDataSupported()) {
        de.ivu.elect.jee.entity.customdata.CustomData result = getCustomDataStorage().getCustomData();
        result.setTechnicalEntity(this); // Fachliche Entität bei jedem Zugriff setzen
        return result;
      }
      return de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE;
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends de.ivu.elect.jee.entity.customdata.CustomData> T getCustomData(Class<T> clazz) {
      if (isCustomDataSupported()) {
        return (T) getCustomData();
      }
      throw new IllegalStateException("Entität StimmeingabePlausiKonfiguration besitzt kein CustomDataStorage...");
    }


    @Override
    public void updateCustomData() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().updateCustomData();
      }
    }


    public void clearCustomDataCache() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().clearCustomDataCache();
      }
    }

    public String getCustomDataXml(){
      if (isCustomDataSupported()) {
        return getCustomDataStorage().getCustomDataXml();
      }
      return "";
    }

    public void setCustomDataXml(String customDataXml){
      if (isCustomDataSupported()) {
        if (org.apache.commons.lang3.StringUtils.isBlank(customDataXml)) {
          if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
            throw new IllegalStateException("Entität StimmeingabePlausiKonfiguration hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
          }
          // ELECTMUC-2581
          System.err.println("Entität StimmeingabePlausiKonfiguration hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
        } else {
          getCustomDataStorage().setCustomDataXml(customDataXml);
        }
        clearCustomDataCache(); // WASDE-1131
      } else {
       if (org.apache.commons.lang3.StringUtils.isNotBlank(customDataXml)) {
         if (customDataXml.endsWith("EmptyCustomData/>")) {
            // Abwärtskompatibilität...alles gut, die alten, leeren CustomDataObjekte...
         } else {
           if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
             throw new IllegalStateException("Entität StimmeingabePlausiKonfiguration hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
           }
           // ELECT-5122
           System.err.println("Entität StimmeingabePlausiKonfiguration hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
         }
       }
      }
    }

    public boolean hasChangedCustomDataXml() {
      if (isCustomDataSupported()) {
        return getCustomDataStorage().hasChangedCustomDataXml();
      }
      return false;
    }


    @javax.persistence.Transient
    private transient StimmeingabePlausiKonfigurationTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public StimmeingabePlausiKonfigurationTK getStimmeingabePlausiKonfigurationTK(){
    if (tkCache==null) {
    tkCache = new StimmeingabePlausiKonfigurationTK(

getErgebniseingangsart()
, getGebietsart()
, getTyp()
,   (getWahl() == null) ? null : getWahl().getWahlTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getStimmeingabePlausiKonfigurationTK();
    }

  @Override
  public StimmeingabePlausiKonfigurationUK getUk(){
    return getStimmeingabePlausiKonfigurationUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return StimmeingabePlausiKonfiguration.class;
  }

public StimmeingabePlausiKonfigurationUK getStimmeingabePlausiKonfigurationUK(){

   return  new StimmeingabePlausiKonfigurationUK(



  );
}

  @javax.persistence.Transient
  private transient StimmeingabePlausiKonfigurationProperties properties;

  public StimmeingabePlausiKonfigurationProperties getProperties(){
    if (properties == null) {
      properties = new StimmeingabePlausiKonfigurationProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public StimmeingabePlausiKonfigurationProperties getStimmeingabePlausiKonfigurationProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL);

        beschreibung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                    
      if (werteVorher.containsKey(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERART_EINZAHL);

        fehlerart =
     (de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiFehlerart) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERMELDUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERMELDUNG_EINZAHL);

        fehlermeldungFormat =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERSCHLUESSEL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERSCHLUESSEL_EINZAHL);

        fehlerschluessel =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                    
      if (werteVorher.containsKey(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_STATUS_EINZAHL);

        status =
     (de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                        }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBeschreibung) {
      result.put(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBeschreibung , beschreibung));
    }
                                                if (isSeitLadenVeraendertFehlerart) {
      result.put(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenFehlerart , fehlerart));
    }
                            if (isSeitLadenVeraendertFehlermeldungFormat) {
      result.put(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERMELDUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenFehlermeldungFormat , fehlermeldungFormat));
    }
                            if (isSeitLadenVeraendertFehlerschluessel) {
      result.put(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERSCHLUESSEL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenFehlerschluessel , fehlerschluessel));
    }
                                                if (isSeitLadenVeraendertStatus) {
      result.put(StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStatus , status));
    }
                                    return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBeschreibung = false;
      wertNachLadenBeschreibung = null;
                                          isSeitLadenVeraendertFehlerart = false;
      wertNachLadenFehlerart = null;
                          isSeitLadenVeraendertFehlermeldungFormat = false;
      wertNachLadenFehlermeldungFormat = null;
                          isSeitLadenVeraendertFehlerschluessel = false;
      wertNachLadenFehlerschluessel = null;
                                          isSeitLadenVeraendertStatus = false;
      wertNachLadenStatus = null;
                                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "STIMMEINGABE_PLAUSI";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "StimmeingabePlausiKonfiguration";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StimmeingabePlausiKonfigurationConstants.BESCHREIBUNG_MAX_LENGTH ,  beschreibung, this, StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ergebniseingangsart, this, StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_ERGEBNISART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(fehlerart, this, StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERART_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StimmeingabePlausiKonfigurationConstants.PLAUSI_FEHLERMELDUNG_MAX_LENGTH ,  fehlermeldungFormat, this, StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERMELDUNG_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(StimmeingabePlausiKonfigurationConstants.PLAUSI_FEHLERSCHLUESSEL_MAX_LENGTH ,  fehlerschluessel, this, StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_FEHLERSCHLUESSEL_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(gebietsart, this, StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_GEBIETSART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_PLAUSI_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(typ, this, StimmeingabePlausiKonfigurationConstants.MESSAGE_KEY_STIMMEINGABE_PLAUSI_TYP_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
